/*
	Minervas 存储和管理minerva
*/
package minerva

import (
	"fmt"
)

type Minervas map[string]*Minerva

func NewMinervas(engine PersistentEngine)(Minervas, error){
	// m := make(map[string]*Minerva)
	m, err := engine.Read()
	if err != nil {
		m = make(map[string]*Minerva)
	}
	return m, err
}

func (minervas Minervas)Has(name string)bool{
	_, ok := minervas[name]
	return ok
}

func (minervas Minervas)Insert(m *Minerva)error{
	if minervas.Has(m.Name) {
		return fmt.Errorf("minerva exists")
	}
	minervas[m.Name] = m
	return nil
}

func (minervas Minervas)Get(name string)(*Minerva, error){
	m, ok := minervas[name]
	if ok {
		return m, nil
	}
	return nil, fmt.Errorf("not found")
}

func (minervas Minervas)Delete(name string)error{
	if minervas.Has(name) {
		delete(minervas, name)
		return nil
	}
	return fmt.Errorf("not found")
}

func (minervas Minervas)Update(m *Minerva)error{
	if minervas.Has(m.Name){
		minervas[m.Name] = m
		return nil
	}
	return fmt.Errorf("not found")
}

func (minervas Minervas)UpSert(m *Minerva)error{
	minervas[m.Name] = m
	return nil
}

func (minervas Minervas)List()([]*Minerva, error){
	res := []*Minerva{}
	for _, v := range minervas {
		res = append(res, v)
	}
	return res, nil
}

func (minervas Minervas)Persist(e PersistentEngine)error{
	return e.Write(minervas)
}